Subject: [PATCH v3 05/10] serial: mps2-uart: add support for early console

From: [email-masked] (Peter Hurley)
Date: Fri, 19 Feb 2016 07:46:57 -0800

On 02/19/2016 01:57 AM, Andy Shevchenko wrote:
> On Fri, Feb 19, 2016 at 11:45 AM, Vladimir Murzin
> <[email-masked]> wrote:
>> On 16/02/16 13:09, Vladimir Murzin wrote:
>>>>> +EARLYCON_DECLARE(mps2, mps2_early_console_setup);
>>>>>>> +OF_EARLYCON_DECLARE(mps2, "arm,mps2-uart", mps2_early_console_setup);
>>>>>
>>>>> IIRC Peter Hurley mentioned you don't need to put both anymore, OF_
>>>>> one is enough.
>>>>>
>>> I've just tried with OF_ only and seems it works fine. Thanks for
>>> pointing at it!
>>>
>>
>> ..and the reason for that was that I had stdout pointing at uart node.
>> Now, while testing v4 I end-up with configuration:
>>
>> 1) no EARLYCON_DECLARE in mps2-uart.c
>> 2) stdout not set
>> 3) cmdline has "earlycon=mps2,0x40004000 console=/dev/ttyMPS"
>>
>> and I don't see bootconsole, but if I avoid 1) everything works fine.
>> So, I'd leave EARLYCON_DECLARE in this patch.
> 
> Peter, what is your comment on this?

That Vladimir is not testing with linux-next.

linux-next has common framework for both command line and OF-defined
earlycons.

Vladimir, if you pull in Greg's tty-next branch, then just

OF_EARLYCON_DECLARE(mps2, "arm,mps2-uart", mps2_early_console_setup);

should enable both command-line and OF-defined earlycons.

Regards,
Peter Hurley